#version 120


/*
.
Modified By CrapDeShoes Shaders, derived from SonicEther v10 rc6 and Chocapic 13
Place two leading Slashes in front of the following '#define' lines in order to disable an option.
.
*/


#define GODRAYS
	#define GODRAYS_EXPOSURE 0.11
	#define GODRAYS_SAMPLES 6
	#define GODRAYS_DECAY 0.95
	#define GODRAYS_DENSITY 0.25			
					
#define TONEMAP
	#define TONEMAP_CURVE 0.5

uniform int isEyeInWater;

uniform sampler2D depthtex0;
uniform sampler2D gnormal;
uniform sampler2D gaux2;
uniform sampler2D composite;


uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferPreviousProjection;

uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;

uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;

uniform vec3 sunPosition;

uniform ivec2 eyeBrightness;

uniform int worldTime;
uniform float aspectRatio;
uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;

varying vec4 texcoord;
varying vec3 sunlight;

float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;
float wetx  = clamp(wetness, 0.0f, 1.0f);


float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;


float getDepth(float depth) {
    return 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));
}
float eDepth(vec2 coord) {
	return texture2D(depthtex0, coord).x;
}
float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}
float luma(vec3 color) {
return dot(color,vec3(0.299, 0.587, 0.114));
}

float pixeldepth = texture2D(depthtex0,texcoord.xy).x;

float depth = texture2D(depthtex0,texcoord.xy).x;

	float timefract = worldTime;

	float TimeSunrise  = ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0) + (1.0 - (clamp(timefract, 0.0, 4000.0)/4000.0));
	float TimeNoon     = ((clamp(timefract, 0.0, 4000.0)) / 4000.0) - ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0);
	float TimeSunset   = ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0) - ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0);
	float TimeMidnight = ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0) - ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0);

float mat(float n) { return fract(sin(n)*43758.5453); }

float noise(vec2 x){
    vec2 p = floor(x), f = fract(x); float n = p.x + p.y*11.0, res = 1.0;
    res = mix(mix(mat(n), mat(n+1),f.x), mix(mat(n+11), mat(n+12),f.x),f.y);
  return res;
}
	 
float getAlphafbm(vec4 fragpos) {

	vec4 wrldpos = gbufferModelViewInverse * fragpos / far * 64.0;

	float common = wrldpos.y + length(wrldpos.y);  

	vec2 camPos = (wrldpos.xz / wrldpos.y);
	vec2 pos = -1.5 + 3.5 * (camPos); float f = 0.25;
	vec2 p = (0.5*pos); pos /= 15.0 + 0.85;

    	f += 0.50*noise(p); p = p*2.1; f += 0.25*noise(p); p = p*2.2;
    	f += 0.175*noise(p); p = p*2.3; f /= 0.925;

	float tex = f, b = 0.6, c = tex - (b+0.175);
	if(c <= 0) c = 0; tex = ((1.0 - pow(b, c)) * common) / 100.0;

    return tex*(1-rainStrength);
}

#ifdef GODRAYS

vec3 sunPos = sunPosition;



	float addGodRays(vec2 lightPos, float nc, vec2 tx, float noise, float noise2, float noise3, float noise4, float noise5, float noise6, float noise7, float noise8, float noise9) {
			float GDTimeMult = 0.0f;
			if (sunPos.z > 0.0f) {
	sunPos.z = -sunPos.z;
	sunPos.x = -sunPos.x;
	sunPos.y = -sunPos.y;
	GDTimeMult = TimeMidnight;	
	} else {
	GDTimeMult = TimeSunrise + TimeNoon + TimeSunset;
	}
	vec2 delta = (tx - lightPos) * GODRAYS_DENSITY / float(2.0);
	delta *= -sunPos.z*0.01f;
	float decay = -sunPos.z / 100.0f, colorGD = 0.0f;
			
			for (int i = 0; i<2;i++) {	
	float sample = 0.0f;
	sample = texture2D(gaux2, clamp(tx + delta*noise,0.000001,0.999999)).b;
	sample += texture2D(gaux2, clamp(tx + delta*noise2,0.000001,0.999999)).b;
	sample += texture2D(gaux2, clamp(tx + delta*noise3,0.000001,0.999999)).b;
	sample += texture2D(gaux2, clamp(tx + delta*noise4,0.000001,0.999999)).b;
	sample *= decay; colorGD += sample; decay *= GODRAYS_DECAY; tx -= delta;	
			}
	return (nc + GODRAYS_EXPOSURE * (colorGD))*GDTimeMult;
	}
#endif 

void main() {

	vec3 color = texture2D(composite, texcoord.st).rgb;
	float land = texture2D(composite, texcoord.st).a;
	
	vec2 Texcoord2 = texcoord.st;

	const float noiseamp = 5.5f, width3 = 2.0f, height3 = 2.0f;

	float noiseX3 = ((fract(1.0f-Texcoord2.s*(width3/2.0f))*0.25f)+(fract(Texcoord2.t*(height3/2.0f))*0.75f))*2.0f-1.0f;
						
	noiseX3 = clamp(fract(sin(dot(Texcoord2 ,vec2(18.9898f,28.633f))) * 4378.5453f),0.0f,1.0f)*2.0f-1.0f;
	noiseX3 *= (0.10f*noiseamp);

	vec4 fragposition = gbufferProjectionInverse * vec4(texcoord.s * 2.0f - 1.0f, texcoord.t * 2.0f - 1.0f, 2.0f * pixeldepth - 1.0f, 1.0f);
	fragposition /= fragposition.w;

	color.rgb *= mix(vec3(1.0),vec3(0.3,0.4,0.6),isEyeInWater);
	float night = TimeMidnight;

	vec3 basic_colour = sunlight*(1-night) + (vec3(4,6,16)/225.0/1.3)*night;
	if (land < 0.1) color.rgb += (basic_colour * getAlphafbm(fragposition));

	vec4 tpos = vec4(sunPos,1.0)*gbufferProjection;
			tpos = vec4(tpos.xyz/tpos.w,1.0);
			vec2 lightPos = tpos.xy/tpos.z;
			lightPos = (lightPos + 1.0f)/2.0f;
			
	float distof = min(min(1.0-lightPos.x,lightPos.x),min(1.0-lightPos.y,lightPos.y));
	float fading = clamp(1.0-step(distof,0.1)+pow(distof*10.0,5.0),0.0,1.0);

	#ifdef GODRAYS		
	if (fading > 0.01) {
			
	float GR = addGodRays(lightPos,0.0f, Texcoord2, noiseX3, noiseX3, noiseX3, noiseX3, noiseX3, noiseX3, noiseX3, noiseX3, noiseX3)/2.0;

	GR = pow(GR, 1.0f)*2.5f;
	color += GR*sunlight*fading;
	}	
	#endif

	color = color / (color + TONEMAP_CURVE) * (1.0+TONEMAP_CURVE);

	gl_FragColor = vec4(color,1.0);
	
// End of Main. -----------------
}